{XMS verze 1.0
 --- 7software (C) Pavel Holeek ---
 Knihovna pro praci s XMS
 Tento unit je freeware
-------------------------------------
 http://7software.wz.cz/
}

{$F+}
unit xms;
interface
type       XFileType=record
                  handle:word;
                  pozition,
                  size:longint;
                end;
var        XMSerror:byte;
var        XMSInfo:record
                     locks,freehandle:byte;
                     length:word;
                     blockseg,blockofs:word;
                    end;

{******* Tady tohle umoznuje zachazet s XMS, jako se souborem **************}
procedure XAssign(var f:XFileType;size:word);
procedure XRead(var f:XFileType;dest:pointer;size:longint);
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
procedure XSeek(var f:XFileType;poz:longint);
function  XSize(var f:XFileType):longint;
function  XPoz(var f:XFileType):longint;
procedure XClose(var f:XFileType);

{******* Zde jsou ostatni (nepohodlne) procedury a funkce pro praci s XMS***}
function  XMSerrmesage(err:byte):string;
function  testXMS:boolean;
function  XMSver:word;
procedure allocHMA(size:word);
procedure deallocHMA;
procedure GlobEnableA20;
procedure GlobDisableA20;
procedure LocalEnableA20;
procedure LocalDisableA20;
function  getA20status:boolean;
function  XMSmaxblock:word;
function  XMSfree:word;
function  allocXMS(size:word):word;
procedure deallocXMS(handle:word);
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
procedure BasetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
procedure XMSblockinfo(handle:word);
procedure reallocXMS(handle,length:word);
procedure LockXMS(handle:word);
procedure unLockXMS(handle:word);
procedure allocUMB(size:word);
procedure deallocUMB(blockseg:word);
function  UMBmaxblock:word;


implementation
uses dos;
var  XMSaddr:longint;
procedure longcall(addr: longint; var regs: registers); external;
{$L INFOPLUS}
{$F-}


function XMSerrmesage(err:byte):string;
begin
 case err of
  0  :XMSerrmesage:='Vsechno OK';
  1  :XMSerrmesage:='Neni pamet XMS';
  $80:XMSerrmesage:='Funkce XMS neni implementovana';
  $81:XMSerrmesage:='Zisteno zarizeni VDISK';
  $82:XMSerrmesage:='Nastala chyba A20';
  $8E:XMSerrmesage:='Obecna chyba ovladace XMS';
  $8F:XMSerrmesage:='Nezotavitelna chyba ovladace XMS';
  $90:XMSerrmesage:='Pamet HMA neexistuje';
  $91:XMSerrmesage:='Pamet HMA je jiz pouzivana';
  $91:XMSerrmesage:='Nevyhovuje parametr /HMAMIN=';
  $93:XMSerrmesage:='Pamet HMA neni pridelena';
  $94:XMSerrmesage:='Hardvare A20 je dosud zapnuto';
  $A0:XMSerrmesage:='Vsechna rozsirena pamet je alokovana';
  $A1:XMSerrmesage:='Vsechny rukojeti rozsirene pameti jsou pozivany';
  $A2:XMSerrmesage:='Rukojet je neplatna';
  $A3:XMSerrmesage:='Zdrojova rukojet je neplatna';
  $A4:XMSerrmesage:='Zdrojovy offset je neplatny';
  $A5:XMSerrmesage:='Cilova rukojet je neplatna';
  $A6:XMSerrmesage:='Cilovy offset je neplatny';
  $A7:XMSerrmesage:='Delka je neplatna';
  $A8:XMSerrmesage:='Presouvane oblasti maji nepovoleny presah';
  $A9:XMSerrmesage:='Nastala chyba parity';
  $AA:XMSerrmesage:='Blok neni uzamcen';
  $AB:XMSerrmesage:='Blok je uzamcen';
  $AC:XMSerrmesage:='Precteni maximalniho poctu zamku bloku';
  $AD:XMSerrmesage:='Uzamceni neuspesne';
  $B0:XMSerrmesage:='K dispozici je mensi blok UMB';
  $B1:XMSerrmesage:='Nejsou dalsi bloky horni pameti';
  $B2:XMSerrmesage:='Cislo segmentu UMB je neplatne';
 end;
end;
function testXMS:boolean;
var r:registers;
begin
 r.ah:=$43;
 r.al:=$00;
 intr($2F,r);
 if r.al=$80 then testXMS:=true else testXMS:=false;
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
 end;
 XMSerror:=0;
end;
function XMSver:word;
var r:registers;
begin
 r.AX:=$4300;
 intr($2F,r);
 if r.al<>$80 then exit else
 begin
  r.AX:=$4310;
  intr($2F,r);
  XMSaddr:=longint(r.es) shl 16 + r.bx;
  r.ax:=0;
  longcall(XMSaddr, r);
  XMSver:=r.ax;
 end;
end;
procedure allocHMA(size:word);
var r:registers;
begin
 r.ah:=01;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure deallocHMA;
var r:registers;
begin
 r.ah:=02;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure GlobEnableA20;
var r:registers;
begin
 r.ah:=03;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure GlobDisableA20;
var r:registers;
begin
 r.ah:=03;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure LocalEnableA20;
var r:registers;
begin
 r.ah:=05;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure LocalDisableA20;
var r:registers;
begin
 r.ah:=06;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
function getA20status:boolean;
var r:registers;
begin
 r.ah:=07;
 longcall(XMSaddr, r);
 if r.ax=$0001 then getA20status:=true else getA20status:=false;
 XMSerror:=r.bl;
end;
function XMSmaxblock:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSmaxblock:=r.ax;
end;
function XMSfree:word;
var r:registers;
begin
 r.ah:=08;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSfree:=r.dx;
end;
function allocXMS(size:word):word;
var r:registers;
begin
 r.ah:=09;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 allocXMS:=r.dx;
end;
procedure deallocXMS(handle:word);
var r:registers;
begin
 r.ah:=$0A;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure moveXMS(SHandle,SSeg,SOfs,DHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=DSeg;Dof:=Dofs;
 end;

 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure basetoXMS(SSeg,SOfs,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=0;Sse:=SSeg;Sof:=SOfs;Dha:=Dhandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoXMS(SHandle,DHandle:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=DHandle;Dse:=0;Dof:=0;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMStoBase(SHandle,DSeg,DOfs:word;Length:longint);
var r:registers;
var struct:record
            len:longint;Sha,Sof,Sse,Dha,Dof,Dse:word;
           end;
begin
 with struct do
 begin
  len:=Length;Sha:=Shandle;Sse:=0;Sof:=0;Dha:=0;Dse:=Dseg;Dof:=Dofs;
 end;
 r.ah:=$0B;
 r.ds:=seg(struct);
 r.si:=ofs(struct);
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure lockXMS(handle:word);
var r:registers;
begin
 r.ah:=$0C;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 r.dx:=XMSinfo.blockseg;
 r.bx:=XMSinfo.blockofs;
end;
procedure unLockXMS(handle:word);
var r:registers;
begin
 r.ah:=$0D;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure XMSblockinfo(handle:word);
var r:registers;
begin
 r.ah:=$0E;
 r.dx:=handle;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSinfo.locks:=r.bh;
 XMSinfo.freehandle:=r.bl;
 XMSinfo.length:=r.dx;
end;
procedure reallocXMS(handle,length:word);
var r:registers;
begin
 r.ah:=$0F;
 r.dx:=handle;
 r.bx:=length;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
procedure allocUMB(size:word);
var r:registers;
begin
 r.ah:=$10;
 r.dx:=size;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 XMSinfo.blockseg:=r.bx;
 XMSinfo.length:=r.dx;
end;
procedure deallocUMB(blockseg:word);
var r:registers;
begin
 r.ah:=$11;
 r.dx:=blockseg;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
end;
function UMBmaxblock:word;
var r:registers;
begin
 r.ah:=$10;
 r.dx:=$FFFF;
 longcall(XMSaddr, r);
 if r.ax=$0001 then XMSerror:=0 else XMSerror:=r.bl;
 UMBmaxblock:=r.dx;
end;
procedure XAssign(var f:XFileType;size:word);
begin
 f.handle:=allocXMS(size);
 f.size:=size;
 f.pozition:=0;
end;
procedure XRead(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(f.handle,f.pozition div 65535,f.pozition mod 65535,0,seg(dest^),ofs(dest^),size);
 f.pozition:=f.pozition+size;
end;
procedure XWrite(var f:XFileType;dest:pointer;size:longint);
begin
 if f.handle=0 then
 begin
  XMSerror:=$A2;
  exit;
 end;
 moveXMS(0,seg(dest^),ofs(dest^),f.handle,f.pozition div 65535,f.pozition mod 65535,size);
 f.pozition:=f.pozition+size;
end;
procedure XSeek(var f:XFileType;poz:longint);
begin
 f.pozition:=poz;
end;
function  XSize(var f:XFileType):longint;
begin
 XSize:=f.size;
end;
function  XPoz(var f:XFileType):longint;
begin
 XPoz:=f.pozition;
end;
procedure XClose(var f:XFileType);
begin
 deallocXMS(f.handle);
end;

{***************** Inicializace ********************************************}
begin
 XMSerror:=0;
 testXMS;
end.